(*#####################################################*)
(*#  Console for Oberon Portable Compiler and Linker  #*)
(*#     ( https://sourceforge.net/projects/opcl )     #*)
(*# Version 1.0 for Win32: 9x,NT,Me,2k,XP,2k3,Vista,7 #*)
(*#  It is free for commercial & non-commercial use.  #*)
(*#                                                   #*)
(*# Copyright (C) 2011-2012, Serg Atantsov            #*)
(*#     e-mail Web_2.0@mail.ru     ICQ 200972129      #*)
(*#                                                   #*)
(*# Copyright (C) 2007-2012, Oleg N. Cher             #*)
(*#  www.zx.oberon2.ru e-mail allot@bk.ru ICQ 2208403 #*)
(*#####################################################*)

MODULE Console; (* non-portable *)

IMPORT
  W := Windows, SYSTEM;

CONST
  Black     = 0;
  Blue      = 1;
  Green     = 2;
  Cyan      = Green + Blue;
  Red       = 4;
  Magenta   = Red + Blue;
  Brown     = Red + Green;
  White     = Red + Green + Blue;
  Light = 8;
  Gray         = Light + Black;
  LightBlue    = Light + Blue;
  LightGreen   = Light + Green;
  LightCyan    = Light + Cyan;
  LightRed     = Light + Red;
  LightMagenta = Light + Magenta;
  Yellow       = Light + Brown;
  LightWhite   = Light + White;

  BlackOnBlack*    = ASH(Black, 4) + Black;
  BlueOnBlack*     = ASH(Black, 4) + Blue;
  GreenOnBlack*    = ASH(Black, 4) + Green;
  CyanOnBlack*     = ASH(Black, 4) + Cyan;
  RedOnBlack*      = ASH(Black, 4) + Red;
  MagentaOnBlack*  = ASH(Black, 4) + Magenta;
  BrownOnBlack*    = ASH(Black, 4) + Brown;
  WhiteOnBlack*    = ASH(Black, 4) + White;
  GrayOnBlack*     = ASH(Black, 4) + Gray;
  LBlueOnBlack*    = ASH(Black, 4) + LightBlue;
  LGreenOnBlack*   = ASH(Black, 4) + LightGreen;
  LCyanOnBlack*    = ASH(Black, 4) + LightCyan;
  LRedOnBlack*     = ASH(Black, 4) + LightRed;
  LMagentaOnBlack* = ASH(Black, 4) + LightMagenta;
  YellowOnBlack*   = ASH(Black, 4) + Yellow;
  LWhiteOnBlack*   = ASH(Black, 4) + LightWhite;

  BlackOnBlue*    = ASH(Blue, 4) + Black;
  BlueOnBlue*     = ASH(Blue, 4) + Blue;
  GreenOnBlue*    = ASH(Blue, 4) + Green;
  CyanOnBlue*     = ASH(Blue, 4) + Cyan;
  RedOnBlue*      = ASH(Blue, 4) + Red;
  MagentaOnBlue*  = ASH(Blue, 4) + Magenta;
  BrownOnBlue*    = ASH(Blue, 4) + Brown;
  WhiteOnBlue*    = ASH(Blue, 4) + White;
  GrayOnBlue*     = ASH(Blue, 4) + Gray;
  LBlueOnBlue*    = ASH(Blue, 4) + LightBlue;
  LGreenOnBlue*   = ASH(Blue, 4) + LightGreen;
  LCyanOnBlue*    = ASH(Blue, 4) + LightCyan;
  LRedOnBlue*     = ASH(Blue, 4) + LightRed;
  LMagentaOnBlue* = ASH(Blue, 4) + LightMagenta;
  YellowOnBlue*   = ASH(Blue, 4) + Yellow;
  LWhiteOnBlue*   = ASH(Blue, 4) + LightWhite;

  BlackOnGreen*    = ASH(Green, 4) + Black;
  BlueOnGreen*     = ASH(Green, 4) + Blue;
  GreenOnGreen*    = ASH(Green, 4) + Green;
  CyanOnGreen*     = ASH(Green, 4) + Cyan;
  RedOnGreen*      = ASH(Green, 4) + Red;
  MagentaOnGreen*  = ASH(Green, 4) + Magenta;
  BrownOnGreen*    = ASH(Green, 4) + Brown;
  WhiteOnGreen*    = ASH(Green, 4) + White;
  GrayOnGreen*     = ASH(Green, 4) + Gray;
  LBlueOnGreen*    = ASH(Green, 4) + LightBlue;
  LGreenOnGreen*   = ASH(Green, 4) + LightGreen;
  LCyanOnGreen*    = ASH(Green, 4) + LightCyan;
  LRedOnGreen*     = ASH(Green, 4) + LightRed;
  LMagentaOnGreen* = ASH(Green, 4) + LightMagenta;
  YellowOnGreen*   = ASH(Green, 4) + Yellow;
  LWhiteOnGreen*   = ASH(Green, 4) + LightWhite;

  BlackOnCyan*    = ASH(Cyan, 4) + Black;
  BlueOnCyan*     = ASH(Cyan, 4) + Blue;
  GreenOnCyan*    = ASH(Cyan, 4) + Green;
  CyanOnCyan*     = ASH(Cyan, 4) + Cyan;
  RedOnCyan*      = ASH(Cyan, 4) + Red;
  MagentaOnCyan*  = ASH(Cyan, 4) + Magenta;
  BrownOnCyan*    = ASH(Cyan, 4) + Brown;
  WhiteOnCyan*    = ASH(Cyan, 4) + White;
  GrayOnCyan*     = ASH(Cyan, 4) + Gray;
  LBlueOnCyan*    = ASH(Cyan, 4) + LightBlue;
  LGreenOnCyan*   = ASH(Cyan, 4) + LightGreen;
  LCyanOnCyan*    = ASH(Cyan, 4) + LightCyan;
  LRedOnCyan*     = ASH(Cyan, 4) + LightRed;
  LMagentaOnCyan* = ASH(Cyan, 4) + LightMagenta;
  YellowOnCyan*   = ASH(Cyan, 4) + Yellow;
  LWhiteOnCyan*   = ASH(Cyan, 4) + LightWhite;

  BlackOnRed*    = ASH(Red, 4) + Black;
  BlueOnRed*     = ASH(Red, 4) + Blue;
  GreenOnRed*    = ASH(Red, 4) + Green;
  CyanOnRed*     = ASH(Red, 4) + Cyan;
  RedOnRed*      = ASH(Red, 4) + Red;
  MagentaOnRed*  = ASH(Red, 4) + Magenta;
  BrownOnRed*    = ASH(Red, 4) + Brown;
  WhiteOnRed*    = ASH(Red, 4) + White;
  GrayOnRed*     = ASH(Red, 4) + Gray;
  LBlueOnRed*    = ASH(Red, 4) + LightBlue;
  LGreenOnRed*   = ASH(Red, 4) + LightGreen;
  LCyanOnRed*    = ASH(Red, 4) + LightCyan;
  LRedOnRed*     = ASH(Red, 4) + LightRed;
  LMagentaOnRed* = ASH(Red, 4) + LightMagenta;
  YellowOnRed*   = ASH(Red, 4) + Yellow;
  LWhiteOnRed*   = ASH(Red, 4) + LightWhite;

  BlackOnMagenta*    = ASH(Magenta, 4) + Black;
  BlueOnMagenta*     = ASH(Magenta, 4) + Blue;
  GreenOnMagenta*    = ASH(Magenta, 4) + Green;
  CyanOnMagenta*     = ASH(Magenta, 4) + Cyan;
  RedOnMagenta*      = ASH(Magenta, 4) + Red;
  MagentaOnMagenta*  = ASH(Magenta, 4) + Magenta;
  BrownOnMagenta*    = ASH(Magenta, 4) + Brown;
  WhiteOnMagenta*    = ASH(Magenta, 4) + White;
  GrayOnMagenta*     = ASH(Magenta, 4) + Gray;
  LBlueOnMagenta*    = ASH(Magenta, 4) + LightBlue;
  LGreenOnMagenta*   = ASH(Magenta, 4) + LightGreen;
  LCyanOnMagenta*    = ASH(Magenta, 4) + LightCyan;
  LRedOnMagenta*     = ASH(Magenta, 4) + LightRed;
  LMagentaOnMagenta* = ASH(Magenta, 4) + LightMagenta;
  YellowOnMagenta*   = ASH(Magenta, 4) + Yellow;
  LWhiteOnMagenta*   = ASH(Magenta, 4) + LightWhite;

  BlackOnBrown*    = ASH(Brown, 4) + Black;
  BlueOnBrown*     = ASH(Brown, 4) + Blue;
  GreenOnBrown*    = ASH(Brown, 4) + Green;
  CyanOnBrown*     = ASH(Brown, 4) + Cyan;
  RedOnBrown*      = ASH(Brown, 4) + Red;
  MagentaOnBrown*  = ASH(Brown, 4) + Magenta;
  BrownOnBrown*    = ASH(Brown, 4) + Brown;
  WhiteOnBrown*    = ASH(Brown, 4) + White;
  GrayOnBrown*     = ASH(Brown, 4) + Gray;
  LBlueOnBrown*    = ASH(Brown, 4) + LightBlue;
  LGreenOnBrown*   = ASH(Brown, 4) + LightGreen;
  LCyanOnBrown*    = ASH(Brown, 4) + LightCyan;
  LRedOnBrown*     = ASH(Brown, 4) + LightRed;
  LMagentaOnBrown* = ASH(Brown, 4) + LightMagenta;
  YellowOnBrown*   = ASH(Brown, 4) + Yellow;
  LWhiteOnBrown*   = ASH(Brown, 4) + LightWhite;

  BlackOnGray*     = ASH(Gray, 4) + Black;
  BlueOnGray*      = ASH(Gray, 4) + Blue;
  GreenOnGray*     = ASH(Gray, 4) + Green;
  CyanOnGray*      = ASH(Gray, 4) + Cyan;
  RedOnGray*       = ASH(Gray, 4) + Red;
  MagentaOnGray*   = ASH(Gray, 4) + Magenta;
  BrownOnGray*     = ASH(Gray, 4) + Brown;
  WhiteOnGray*     = ASH(Gray, 4) + White;
  GrayOnGray*      = ASH(Gray, 4) + Gray;
  LBlueOnGray*     = ASH(Gray, 4) + LightBlue;
  LGreenOnGray*    = ASH(Gray, 4) + LightGreen;
  LCyanOnGray*     = ASH(Gray, 4) + LightCyan;
  LRedOnGray*      = ASH(Gray, 4) + LightRed;
  LMagentaOnGray*  = ASH(Gray, 4) + LightMagenta;
  YellowOnGray*    = ASH(Gray, 4) + Yellow;
  LWhiteOnGray*    = ASH(Gray, 4) + LightWhite;
  
  BlackOnWhite*    = ASH(White, 4) + Black;
  BlueOnWhite*     = ASH(White, 4) + Blue;
  GreenOnWhite*    = ASH(White, 4) + Green;
  CyanOnWhite*     = ASH(White, 4) + Cyan;
  RedOnWhite*      = ASH(White, 4) + Red;
  MagentaOnWhite*  = ASH(White, 4) + Magenta;
  BrownOnWhite*    = ASH(White, 4) + Brown;
  WhiteOnWhite*    = ASH(White, 4) + White;
  GrayOnWhite*     = ASH(White, 4) + Gray;
  LBlueOnWhite*    = ASH(White, 4) + LightBlue;
  LGreenOnWhite*   = ASH(White, 4) + LightGreen;
  LCyanOnWhite*    = ASH(White, 4) + LightCyan;
  LRedOnWhite*     = ASH(White, 4) + LightRed;
  LMagentaOnWhite* = ASH(White, 4) + LightMagenta;
  YellowOnWhite*   = ASH(White, 4) + Yellow;
  LWhiteOnWhite*   = ASH(White, 4) + LightWhite;

  MaxPathLength* = W.MAX_PATH;

TYPE
  Integer = LONGINT;
  Colors* = Integer;
  String = ARRAY OF CHAR;

  CONSOLE_DATA*                             =  RECORD
    EventType*   : LONGINT;
    KeyDown*     : LONGINT;
    KeyChar*     : CHAR;
    KeyCode*     : INTEGER;
    MouseX*      : INTEGER;
    MouseY*      : INTEGER;
    MouseBState* : SET;
    MouseCState* : SET;
    MouseEState* : SET;
  END;
  
VAR
  hIn*, hOut*   : W.HANDLE;
  char: ARRAY 2 OF CHAR;
  crlf: ARRAY 3 OF CHAR;

PROCEDURE IntToStr*(val: LONGINT): ARRAY OF CHAR;
VAR
  i, j  : LONGINT;
  str   : ARRAY 16 OF CHAR;
  digits: ARRAY 16 OF LONGINT;
BEGIN
    IF val = MIN(LONGINT) THEN
       COPY("-2147483648", str);
       RETURN str
    END;
    IF val < 0 THEN
       val := -val;
       str[0] := "-";
       j := 1
    ELSE
       j := 0
    END;
    i := 0;
    REPEAT
       digits[i] := val MOD 10;
       INC(i);
       val := val DIV 10
    UNTIL val = 0;
    DEC(i);
    WHILE i >= 0 DO
       str[j] := CHR(digits[i]+ORD("0"));
       INC(j);
       DEC(i)
    END;
    str[j] := 0X;
    RETURN str;
END IntToStr;

PROCEDURE Length* (str: String): Integer;
(* Returns length of a null-terminated string (without final 0X) *)
VAR
  len, maxLen: Integer;
BEGIN
  maxLen := LEN(str);
  len := 0;
  WHILE (len < maxLen) & (str[len] # 0X) DO INC(len) END;
  RETURN len;
END Length;

PROCEDURE Cap* (ch: CHAR): CHAR;
(* Returns the capital letter of a char (does not change non-alpha chars) *)
CONST
  Aa = ORD("a") - ORD("A");
BEGIN
  CASE ch OF
    "a".."z": RETURN CHR(ORD(ch) - Aa)
  ELSE END;
  RETURN ch
END Cap;

PROCEDURE toOEM* (str: String): String;
VAR
  n,i,c:Integer;
BEGIN
  n:=Length(str);
  i:=0;
  WHILE (i<n) DO
    c:=ORD(str[i]);
    IF    (c>=192) & (c<=239) THEN c:=c-64;
    ELSIF (c>=240) & (c<=255) THEN c:=c-16;
    ELSIF (c=168)             THEN c:=240;
    ELSIF (c=184)             THEN c:=241;
    END;
    str[i]:=CHR(c);
    INC(i);
  END;
  RETURN str;
END toOEM;

PROCEDURE WriteStr* (str: String);
VAR
  n,i,c:Integer;
BEGIN
  n:=Length(str);
  W.WriteFile(hOut, str, n, NIL, NIL);
END WriteStr;

PROCEDURE WriteBuff* (str: String);
VAR
  n:Integer;
BEGIN
  n:=LEN(str);
  W.WriteFile(hOut, str, n, NIL, NIL);
END WriteBuff;

PROCEDURE Write* (ch: CHAR);
BEGIN
  W.WriteFile(hOut, ch, 1, NIL, NIL);
END Write;

PROCEDURE WriteCh* (ch: CHAR);
BEGIN
  char[0] := ch; WriteStr(char);
END WriteCh;

PROCEDURE WriteLn* ;
BEGIN
  WriteStr(crlf);
END WriteLn;

PROCEDURE WriteInt*(X: Integer) ;
BEGIN
  WriteStr(IntToStr(X));
END WriteInt;

PROCEDURE ReadString* (VAR str: String);
VAR
  n,i,c:Integer;
BEGIN
  n:=LEN(str);
  W.ReadFile(hIn, str, n, n, NIL);
  str[n-2]:=0X; (* - 0AX 0DX *)

  i:=0;
  WHILE i<n DO
    c:=ORD(str[i]);
    IF    (c>=192) & (c<=239) THEN c:=c+16;
    ELSIF (c=240)             THEN c:=168;
    ELSIF (c=241)             THEN c:=184;
    ELSIF (c=168)             THEN c:=232;
    END;
    str[i]:=CHR(c);
    INC(i);
  END;

END ReadString;

PROCEDURE Read* ();
VAR
  c: CHAR;
BEGIN
  W.ReadFile(hIn, c, 1, NIL, NIL);
END Read;


(*#################################################################*)

PROCEDURE TCOORD (x, y: Integer): Integer;
BEGIN
  RETURN ASH(SHORT(y),16)+SHORT(x);
END TCOORD;

PROCEDURE GotoXY* (x, y: Integer);
BEGIN
  W.SetConsoleCursorPosition(hOut,TCOORD(x,y));
END GotoXY;

PROCEDURE Cls* ();
VAR
  fill: Integer;
  ScrBufInfo: W.CONSOLE_SCREEN_BUFFER_INFO;
BEGIN
  W.GetConsoleScreenBufferInfo(hOut, ScrBufInfo);
  fill := ScrBufInfo.dwSize.X * ScrBufInfo.dwSize.Y;
  W.FillConsoleOutputCharacter(hOut, " ", fill,TCOORD(0,0), fill);
  GotoXY(0,0);
END Cls;

PROCEDURE Fill* (Color: Integer) ;
VAR
  fill: Integer;
  ScrBufInfo: W.CONSOLE_SCREEN_BUFFER_INFO;
BEGIN
  W.GetConsoleScreenBufferInfo(hOut, ScrBufInfo);
  fill := ScrBufInfo.dwSize.X * ScrBufInfo.dwSize.Y;
  W.FillConsoleOutputCharacter(hOut, " ", fill,TCOORD(0,0), fill);
  SetColors(Color);
  W.FillConsoleOutputAttribute(hOut, SHORT(Color), fill,TCOORD(0,0), fill);
  GotoXY(0,0);
END Fill;

PROCEDURE SetTitle* (title: String);
BEGIN
  W.SetConsoleTitle(title);
END SetTitle;
                                      
PROCEDURE SetColors* (attr: Colors);
BEGIN
  W.SetConsoleTextAttribute(hOut, SHORT(attr));
END SetColors;

PROCEDURE StringOfChar* (ch: CHAR; num: Integer);
BEGIN
  WHILE num > 0 DO WriteCh(ch); DEC(num) END;
END StringOfChar;

PROCEDURE HideCursor* ();
VAR
  CCI: W.CONSOLE_CURSOR_INFO;
BEGIN
  W.GetConsoleCursorInfo(hOut,CCI);
  CCI.bVisible:=0;
  W.SetConsoleCursorInfo(hOut,CCI);
END HideCursor;

PROCEDURE ShowCursor* ();
VAR
  CCI: W.CONSOLE_CURSOR_INFO;
BEGIN
  W.GetConsoleCursorInfo(hOut,CCI);
  CCI.bVisible:=1;
  W.SetConsoleCursorInfo(hOut,CCI);
END ShowCursor;

PROCEDURE ScrollRect* (FromX1,FromY1,FromX2,FromY2,ToX,ToY: Integer; Char: CHAR; Attrib: Integer);
VAR
  C_I: W.CHAR_INFO;
  R1,R2 : W.SMALL_RECT;
BEGIN
   R1.left  := SHORT(FromX1);
   R1.top   := SHORT(FromY1);
   R1.right := SHORT(FromX2);
   R1.bottom:= SHORT(FromY2);
   C_I.Char := Char;
   C_I.Attributes := SHORT(Attrib);
   W.ScrollConsoleScreenBuffer(hOut,R1,NIL,TCOORD(ToX,ToY),C_I);
END ScrollRect;

PROCEDURE SetSize* (width, height: Integer);
VAR
  info: W.CONSOLE_SCREEN_BUFFER_INFO;
  bufferSize: W.COORD;
  windowSize: W.SMALL_RECT;
  height_buf: Integer;
BEGIN
  height_buf := height;
  W.GetConsoleScreenBufferInfo(hOut, info);
  bufferSize := info.dwSize;
  IF bufferSize.X <= width THEN bufferSize.X := SHORT(width); END;
  IF bufferSize.Y <= height_buf THEN bufferSize.Y := SHORT(height_buf); END;
  W.SetConsoleScreenBufferSize(hOut, TCOORD(bufferSize.X,bufferSize.Y));
  windowSize.left   := 0;
  windowSize.top    := 0;
  windowSize.right  := SHORT(width - 1);
  windowSize.bottom := SHORT(height - 1);
  W.SetConsoleWindowInfo(hOut, 1, windowSize);
  bufferSize.X := SHORT(width);
  bufferSize.Y := SHORT(height_buf);
  W.SetConsoleScreenBufferSize(hOut, TCOORD(bufferSize.X,bufferSize.Y));
END SetSize;

PROCEDURE SetFont* (Num: Integer);
BEGIN
  W.SetConsoleFont(hOut,Num);
END SetFont;

PROCEDURE ReadConsoleData* (VAR CD: CONSOLE_DATA);
VAR
  r  : LONGINT;
  IRX: W.INPUT_RECORD_X;
  IR : W.INPUT_RECORD;
BEGIN
  
  W.ReadConsoleInputX(hIn, IRX, 1, r);
  CD.EventType:=IRX.EventType;
  
  CASE IRX.EventType OF
      W.KEY_EVENT:
                  SYSTEM.MOVE(SYSTEM.ADR(IRX.Event.Data), 
                              SYSTEM.ADR(IR.Event.KeyEvent),
                              SIZE(W.KEY_EVENT_RECORD));
                  CD.KeyDown:=IR.Event.KeyEvent.bKeyDown;
                  CD.KeyChar:=IR.Event.KeyEvent.UnicodeChar;
                  CD.KeyCode:=IR.Event.KeyEvent.wVirtualKeyCode;
    | W.MOUSE_EVENT: 
                  SYSTEM.MOVE(SYSTEM.ADR(IRX.Event.Data), 
                              SYSTEM.ADR(IR.Event.MouseEvent),
                              SIZE(W.MOUSE_EVENT_RECORD));
                  CD.MouseX:=IR.Event.MouseEvent.dwMousePosition.X;
                  CD.MouseY:=IR.Event.MouseEvent.dwMousePosition.Y;
                  CD.MouseBState:=IR.Event.MouseEvent.dwButtonState;
                  CD.MouseCState:=IR.Event.MouseEvent.dwControlKeyState;
                  CD.MouseEState:=IR.Event.MouseEvent.dwEventFlags;
  ELSE
  END;
          
END ReadConsoleData;

BEGIN
  crlf[0] := 0DX; crlf[1] := 0AX; crlf[2] := 0X; char[1] := 0X;
  hIn  := W.GetStdHandle(W.STD_INPUT_HANDLE);
  hOut := W.GetStdHandle(W.STD_OUTPUT_HANDLE);
END Console.
