MODULE Program1;

IMPORT 
	SYSTEM, C:=Console, W:=Windows;

CONST
  GAME_WIDTH = 80;
  GAME_HEIGHT = 48;
  ST_GAME = 1;
  ST_MENU = 2;
  Wall = CHR(178);
  Tonnel = ' ';
  Box = 'X';
  
TYPE
  TLevel  = ARRAY (GAME_HEIGHT DIV 3) OF ARRAY (GAME_WIDTH DIV 3)+1 OF CHAR;
  TPlayer = RECORD
    X,Y: LONGINT;
  END;
  
VAR 
  CD                     : C.CONSOLE_DATA;
  Menu                   : ARRAY 5 OF ARRAY 20 OF CHAR;
  Status, r              : LONGINT;
  CurrentMenu            : LONGINT;
  Exit                   : BOOLEAN;
  GameLevel              : TLevel;
  Levels                 : ARRAY 14 OF TLevel;
  S                      : ARRAY 1 OF CHAR;
  OldPlayer, Player      : TPlayer;
  Parking                : ARRAY 50 OF TPlayer;
  MaxParking,I,L,NumLevel: LONGINT;
  DeltaX,DeltaY          : LONGINT;
  Obs                    : CHAR;
  
PROCEDURE DrawMenu(N: LONGINT);
VAR
  Count,Width,i: LONGINT;
  Left,Top   : LONGINT;
BEGIN
  
  Count:=LEN(Menu);
  Width:=LEN(Menu[0]);
  Left:= (GAME_WIDTH-Width) DIV 2;
  Top := (GAME_HEIGHT-Count) DIV 2;
  
  C.SetColors(C.LWhiteOnBlue);
  
  C.GotoXY(Left,Top);
  C.Write(0C9X); C.StringOfChar(0CDX,17);C.Write(0BBX);
  INC(Top); 
  
  i:=0;
  WHILE i<Count DO
    C.GotoXY(Left,Top);
    
    C.Write(0BAX);
    IF N=i THEN C.SetColors(C.LWhiteOnRed); ELSE C.SetColors(C.LWhiteOnBlue); END;
    C.WriteStr(C.toOEM(Menu[i]));
    C.Write(0BAX);
    C.SetColors(C.BlackOnBlack);C.Write(020X);C.SetColors(C.LWhiteOnBlue);      
    
    INC(Top); INC(i);
  END;
  C.GotoXY(Left,Top);
  C.Write(0C8X); C.StringOfChar(0CDX,17);C.Write(0BCX);
  C.SetColors(C.BlackOnBlack);C.Write(020X);
  C.GotoXY(Left+1,Top+1);C.StringOfChar(0CDX,19);
  
  C.SetColors(C.LWhiteOnGray);

END DrawMenu;

PROCEDURE DrawWall(X,Y: LONGINT);
BEGIN
  C.SetColors(C.LWhiteOnBlack);
  C.GotoXY(X,Y);
  C.StringOfChar(Wall,3);
  C.GotoXY(X,Y+1);
  C.StringOfChar(Wall,3);
  C.GotoXY(X,Y+2);
  C.StringOfChar(Wall,3);
  C.SetColors(C.LWhiteOnGray);
END DrawWall;

PROCEDURE DrawParking(X,Y: LONGINT);
BEGIN
  C.GotoXY(X,Y);
  C.SetColors(C.WhiteOnBlack);
  C.Write(CHR(201)); C.Write(CHR(205)); C.Write(CHR(187));
  C.GotoXY(X,Y+1);
  C.Write(CHR(186)); C.Write(CHR(206)); C.Write(CHR(186));
  C.GotoXY(X,Y+2);
  C.Write(CHR(200)); C.Write(CHR(205)); C.Write(CHR(188));
  C.SetColors(C.LWhiteOnGray);
END DrawParking;

PROCEDURE DrawBox(Clr,X,Y: LONGINT);
BEGIN
  C.GotoXY(X,Y);
  C.SetColors(Clr);
  C.Write(CHR(218)); C.Write(CHR(205)); C.Write(CHR(191));
  C.GotoXY(X,Y+1);
  C.Write(CHR(186)); C.Write(CHR(216)); C.Write(CHR(186));
  C.GotoXY(X,Y+2);
  C.Write(CHR(192)); C.Write(CHR(205)); C.Write(CHR(217));
  C.SetColors(C.LWhiteOnGray);
END DrawBox;

PROCEDURE DrawTonnel(X,Y: LONGINT);
BEGIN
  C.GotoXY(X,Y);
  C.SetColors(C.BlackOnBlack);
  C.StringOfChar(Tonnel,3);
  C.GotoXY(X,Y+1);
  C.StringOfChar(Tonnel,3);
  C.GotoXY(X,Y+2);
  C.StringOfChar(Tonnel,3);
  C.SetColors(C.LWhiteOnGray);
END DrawTonnel;

PROCEDURE DrawPlayer(X,Y: LONGINT);
BEGIN
  C.GotoXY(X,Y);
  C.SetColors(C.YellowOnBlack);
  C.Write(0BEX); C.Write(0D1X); C.Write(0D4X);
  C.GotoXY(X,Y+1);
  C.Write(0C7X); C.SetColors(C.LGreenOnBlack); C.Write(0D8X); C.SetColors(C.YellowOnBlack); C.Write(0B6X);
  C.GotoXY(X,Y+2);
  C.Write(0B8X); C.Write(0CFX); C.Write(0D5X);
  C.SetColors(C.LWhiteOnGray);
END DrawPlayer;

PROCEDURE LoadLevels(level: LONGINT);
VAR
  X,Y: LONGINT;
  Ch : CHAR;
BEGIN
  IF (level<=0) OR (level>LEN(Levels)) THEN RETURN; END;
  GameLevel:=Levels[level-1];
  MaxParking:=0;
  FOR Y:=0 TO LEN(GameLevel)-1 DO
    FOR X:=0 TO LEN(GameLevel[0])-1 DO
      CASE GameLevel[Y,X] OF
        | '0': DrawTonnel(X*3,Y*3);
        | '1': DrawWall(X*3,Y*3);
        | '2','6': 
               DrawParking(X*3,Y*3);
               Parking[MaxParking].X:=X*3;
               Parking[MaxParking].Y:=Y*3;
               INC(MaxParking);
        | '3': DrawBox(C.LRedOnBlack,X*3,Y*3);
        | '4':               
               Player.X:=X*3;
               Player.Y:=Y*3;
               DrawPlayer(Player.X,Player.Y);
      ELSE
      END;
    END;
  END;
END LoadLevels;

PROCEDURE InitGame();
BEGIN
  
  Levels[0][0]   := " ";
  Levels[0][1]   := " ";
  Levels[0][2]   := "        11111          ";
  Levels[0][3]   := "        10001          ";
  Levels[0][4]   := "        13001          ";
  Levels[0][5]   := "      11100311         ";
  Levels[0][6]   := "      10030301         ";
  Levels[0][7]   := "    1110101101   111111";
  Levels[0][8]   := "    1000101101111100221";
  Levels[0][9]   := "    1030030000000000221";
  Levels[0][10]  := "    1111101110141100221";
  Levels[0][11]  := "        100000111111111";
  Levels[0][12]  := "        1111111        ";
  Levels[0][13]  := " ";
  Levels[0][14]  := " ";
  Levels[0][15]  := " ";
  
  Levels[1][0]   := " ";
  Levels[1][1]   := " ";
  Levels[1][2]   := " ";
  Levels[1][3]   := "      1111111111111  ";
  Levels[1][4]   := "      122000100000111";
  Levels[1][5]   := "      122000103003001";
  Levels[1][6]   := "      122000131111001";
  Levels[1][7]   := "      122000040011001";
  Levels[1][8]   := "      122000101003011";
  Levels[1][9]   := "      111111101130301";
  Levels[1][10]  := "         103003030301";
  Levels[1][11]  := "         100001000001";
  Levels[1][12]  := "         111111111111";
  Levels[1][13]  := " ";
  Levels[1][14]  := " ";
  Levels[1][15]  := " ";
  
  Levels[2][0]   := " ";
  Levels[2][1]   := " ";
  Levels[2][2]   := " ";
  Levels[2][3]   := "             11111111 ";
  Levels[2][4]   := "             10000041 ";
  Levels[2][5]   := "             10313011 ";
  Levels[2][6]   := "             1030031  ";
  Levels[2][7]   := "             1130301  ";
  Levels[2][8]   := "     11111111103010111";
  Levels[2][9]   := "     12222001103003001";
  Levels[2][10]   := "     11222000030030001";
  Levels[2][11]  := "     12222001111111111";
  Levels[2][12]  := "     11111111         ";
  Levels[2][13]  := " ";
  Levels[2][14]  := " ";
  Levels[2][15]  := " ";
  
  Levels[3][0]   := " ";
  Levels[3][1]   := "               11111111";
  Levels[3][2]   := "               10022221";
  Levels[3][3]   := "    1111111111110022221";
  Levels[3][4]   := "    1000010030300022221";
  Levels[3][5]   := "    1033313003010022221";
  Levels[3][6]   := "    1003000003010022221";
  Levels[3][7]   := "    1033013030311111111";
  Levels[3][8]   := "    100301000001       ";
  Levels[3][9]   := "    110111111111       ";
  Levels[3][10]  := "    100001000011       ";
  Levels[3][11]  := "    100000300011       ";
  Levels[3][12]  := "    100331330041       ";
  Levels[3][13]  := "    100001000011       ";
  Levels[3][14]  := "    11111111111        ";
  Levels[3][15]  := " ";
  
  Levels[4][0]   := " ";
  Levels[4][1]   := "             11111    ";
  Levels[4][2]   := "             100011111";
  Levels[4][3]   := "             101311001";
  Levels[4][4]   := "             100000301";
  Levels[4][5]   := "     11111111101110001";
  Levels[4][6]   := "     12222001103003111";
  Levels[4][7]   := "     1222200003033011 ";
  Levels[4][8]   := "     1222200113003041 ";
  Levels[4][9]   := "     1111111110030011 ";
  Levels[4][10]  := "             10303001 ";
  Levels[4][11]  := "             11101101 ";
  Levels[4][12]  := "               100001 ";
  Levels[4][13]  := "               111111 ";
  Levels[4][14]  := " ";
  Levels[4][15]  := " ";
  
  Levels[5][0]   := " ";
  Levels[5][1]   := " ";
  Levels[5][2]   := "        111111  111 ";
  Levels[5][3]   := "        122001 11411";
  Levels[5][4]   := "        122001110001";
  Levels[5][5]   := "        122000003301";
  Levels[5][6]   := "        122001010301";
  Levels[5][7]   := "        122111010301";
  Levels[5][8]   := "        111103013001";
  Levels[5][9]   := "           100310301";
  Levels[5][10]  := "           103003001";
  Levels[5][11]  := "           100110001";
  Levels[5][12]  := "           111111111";
  Levels[5][13]  := " ";
  Levels[5][14]  := " ";
  Levels[5][15]  := " ";
  
  Levels[6][0]   := " ";
  Levels[6][1]   := " ";
  Levels[6][2]   := "              11111 ";
  Levels[6][3]   := "        111111100011";
  Levels[6][4]   := "       1101041103301";
  Levels[6][5]   := "       1000030000001";
  Levels[6][6]   := "       1003001110001";
  Levels[6][7]   := "       1110111113111";
  Levels[6][8]   := "       103001110221 ";
  Levels[6][9]   := "       103030302221 ";
  Levels[6][10]  := "       100001112221 ";
  Levels[6][11]  := "       103301 12221 ";
  Levels[6][12]  := "       100111 11111 ";
  Levels[6][13]  := "       1111         ";
  Levels[6][13]  := " ";
  Levels[6][14]  := " ";
  Levels[6][15]  := " ";
  
  Levels[7][0]   := "       1111          ";
  Levels[7][1]   := "       10011111111111";
  Levels[7][2]   := "       10000300030301";
  Levels[7][3]   := "       10310301003001";
  Levels[7][4]   := "       10030300100001";
  Levels[7][5]   := "     1110310100111101";
  Levels[7][6]   := "     1413030300110001";
  Levels[7][7]   := "     1000030131000101";
  Levels[7][8]   := "     1000300003030301";
  Levels[7][9]   := "     1111100111111111";
  Levels[7][10]  := "       10000001      ";
  Levels[7][11]  := "       10000001      ";
  Levels[7][12]  := "       12222221      ";
  Levels[7][13]  := "       12222221      ";
  Levels[7][14]  := "       12222221      ";
  Levels[7][15]  := "       11111111      ";
  
  Levels[8][0]   := " ";
  Levels[8][1]   := "               1111111";
  Levels[8][2]   := "               1002221";
  Levels[8][3]   := "           11111002221";
  Levels[8][4]   := "           10000002021";
  Levels[8][5]   := "           10011002221";
  Levels[8][6]   := "           11011002221";
  Levels[8][7]   := "          111011111111";
  Levels[8][8]   := "          10333011    ";
  Levels[8][9]  := "      1111100303011111";
  Levels[8][10]  := "     11000130300010001";
  Levels[8][11]  := "     14030030000300301";
  Levels[8][12]  := "     11111103303011111";
  Levels[8][13]  := "          10000001    ";
  Levels[8][14]  := "          11111111    ";
  Levels[8][15]  := " ";
  
  Levels[9][0]   := "     111  1111111111111";
  Levels[9][1]   := "    1141111000000010001";
  Levels[9][2]   := "    1033000330030302221";
  Levels[9][3]   := "    1003331000030012221";
  Levels[9][4]   := "    1030001033033012221";
  Levels[9][5]   := "    1110001003000012221";
  Levels[9][6]   := "    1000001030303012221";
  Levels[9][7]   := "    1000011111101112221";
  Levels[9][8]   := "    1101001003030012221";
  Levels[9][9]   := "    1001101033030311221";
  Levels[9][10]  := "    1022101003000000121";
  Levels[9][11]  := "    1022101033303330121";
  Levels[9][12]  := "    1111101000000010121";
  Levels[9][13]  := "        101111111110121";
  Levels[9][14]  := "        100000000000121";
  Levels[9][15]  := "        111111111111111";
  

  Levels[10][4]   := "           111111 ";
  Levels[10][5]   := "         11100001 ";
  Levels[10][6]   := "        1120311011";
  Levels[10][7]   := "        1223030041";
  Levels[10][8]   := "        1220303011";
  Levels[10][9]   := "        111111001 ";
  Levels[10][10]  := "             1111 ";

  
  Levels[11][4]   := "         111111   ";
  Levels[11][5]   := "         100001   ";
  Levels[11][6]   := "         1033311  ";
  Levels[11][7]   := "         100122111";
  Levels[11][8]   := "         110022301";
  Levels[11][9]   := "          10400001";
  Levels[11][10]  := "          11111111";
  
  Levels[12][2]   := "         1111        ";
  Levels[12][3]   := "     11111001        ";
  Levels[12][4]   := "     10030301 1111111";
  Levels[12][5]   := "     10003001 1626261";
  Levels[12][6]   := "     1103030111262621";
  Levels[12][7]   := "      130300100626261";
  Levels[12][8]   := "      143030000262611";
  Levels[12][9]   := "      130300100626261";
  Levels[12][10]  := "     1103030111262621";
  Levels[12][11]  := "     10003001 1626261";
  Levels[12][12]  := "     10030301 1111111";
  Levels[12][13]  := "     11111001        ";
  Levels[12][14]  := "         1111        ";
  
END InitGame;

BEGIN

  Exit:=FALSE;
  
  NumLevel:=1;
  
  C.SetSize(GAME_WIDTH,GAME_HEIGHT);
  C.Fill(C.LWhiteOnGray);
  C.SetTitle("'Sokoban' console game.");
  C.HideCursor();
  
  (*C.SetFont(3);*)
  
  C.GotoXY((GAME_WIDTH-11) DIV 2,(GAME_HEIGHT-1) DIV 2);
  C.WriteStr(C.toOEM('...'));
  
  W.mciSendString("open 1.mid type sequencer alias MUSIC", NIL, 0, 0); 
  
  Menu[0] := '             ';
  Menu[1] := '        ';
  Menu[2] := '       ';
  Menu[3] := '       ';
  Menu[4] := '            ';
  
  CurrentMenu:=0;
  DrawMenu(CurrentMenu);
  
  Status := ST_MENU;
  
  W.mciSendString("play MUSIC from 0", NIL, 0, 0); 
    
  REPEAT
    
    W.GetNumberOfConsoleInputEvents(C.hIn,r);
    C.ReadConsoleData(CD);
    
    CASE CD.EventType OF
      W.KEY_EVENT  :
                     IF Status=ST_MENU THEN 
                     
                         CASE CD.KeyCode OF
                         
                         |  W.VK_UP  :
                                          IF (CurrentMenu>0) & (CD.KeyDown=1) THEN 
                                            DEC(CurrentMenu);
                                            DrawMenu(CurrentMenu);
                                          END;                             
                         |  W.VK_DOWN:
                                          IF (CurrentMenu<LEN(Menu)-1) & (CD.KeyDown=1) THEN 
                                            INC(CurrentMenu);
                                            DrawMenu(CurrentMenu);
                                          END;
                         |  W.VK_SPACE,
                            W.VK_RETURN : 
                                       CASE CurrentMenu OF
                                         |  0:
                                               C.Fill(C.LWhiteOnGray); 
                                               InitGame();
                                               LoadLevels(NumLevel);
                                               Status:=ST_GAME;
                                               
                                         |  1: W.mciSendString("play MUSIC", NIL, 0, 0);
                                         |  2: W.mciSendString("pause MUSIC", NIL, 0, 0);
                                         |  3:;
                                         |  4: 
                                               Exit:=TRUE;
                                               W.mciSendString("stop MUSIC", NIL, 0, 0);
                                               W.mciSendString("close MUSIC", NIL, 0, 0);
                                       ELSE
                                       END;
                                          
                         ELSE
                         END;
                       
                     ELSIF (Status=ST_GAME) & (CD.KeyDown=1) THEN
                     
                       OldPlayer:= Player;
                       DeltaX := 0;
                       DeltaY := 0;
                       
                       CASE CD.KeyCode OF                         
                       |  W.VK_UP    : DEC(DeltaY,3);                             
                       |  W.VK_DOWN  : INC(DeltaY,3);
                       |  W.VK_LEFT  : DEC(DeltaX,3);
                       |  W.VK_RIGHT : INC(DeltaX,3);
                       |  W.VK_SPACE : 
                                       IF NumLevel<LEN(Levels)-1 THEN
                                         INC(NumLevel); 
                                       ELSE
                                         NumLevel:=1;
                                       END;
                                       C.Fill(C.LWhiteOnGray); 
                                       LoadLevels(NumLevel);
                                       W.mciSendString("play MUSIC from 0", NIL, 0, 0);
                       ELSE
                       END;
                       
                       Obs:=GameLevel[(Player.Y+DeltaY) DIV 3,(Player.X+DeltaX) DIV 3];
                       
                       CASE Obs OF                         
                       |  '0','2' : 
                                INC(Player.X,DeltaX);
                                INC(Player.Y,DeltaY);
                                DrawTonnel(OldPlayer.X,OldPlayer.Y);
                                
                                GameLevel[OldPlayer.Y DIV 3,OldPlayer.X DIV 3]:='0';
                                GameLevel[Player.Y DIV 3,Player.X DIV 3]:='4'; 
                       |  '3','6' : 
                                IF    DeltaX # 0 THEN
                                  Obs:=GameLevel[(Player.Y+DeltaY) DIV 3,(Player.X+DeltaX*2) DIV 3];
                                  IF (Obs='0') OR (Obs='2') THEN
                                    INC(Player.X,DeltaX);
                                    DrawTonnel(OldPlayer.X,OldPlayer.Y);                                    
                                    
                                    DrawTonnel(Player.X+DeltaX,Player.Y);
                                    DrawBox(C.LRedOnBlack,Player.X+DeltaX,Player.Y);
                                    
                                    GameLevel[OldPlayer.Y DIV 3,OldPlayer.X DIV 3]:='0';
                                    GameLevel[Player.Y DIV 3,Player.X DIV 3]:='4';
                                    GameLevel[Player.Y DIV 3,(Player.X+DeltaX) DIV 3]:='3';
                                  END;
                                ELSIF DeltaY # 0 THEN
                                  Obs:=GameLevel[(Player.Y+DeltaY*2) DIV 3,(Player.X+DeltaX) DIV 3];
                                  IF (Obs='0') OR (Obs='2') THEN
                                    INC(Player.Y,DeltaY);
                                    DrawTonnel(OldPlayer.X,OldPlayer.Y);                                  
                                    
                                    DrawTonnel(Player.X,Player.Y+DeltaY);
                                    DrawBox(C.LRedOnBlack,Player.X,Player.Y+DeltaY);
                                    
                                    GameLevel[OldPlayer.Y DIV 3,OldPlayer.X DIV 3]:='0';
                                    GameLevel[Player.Y DIV 3,Player.X DIV 3]:='4';
                                    GameLevel[(Player.Y+DeltaY) DIV 3,Player.X DIV 3]:='3';
                                  END;
                                END;                            
                       ELSE
                       END;
                     
                       I:=0;
                       L:=0;
                       WHILE I<MaxParking DO
                         IF (GameLevel[Parking[I].Y DIV 3,Parking[I].X DIV 3]#'3') 
                         &  (GameLevel[Parking[I].Y DIV 3,Parking[I].X DIV 3]#'6') THEN
                           DrawParking(Parking[I].X,Parking[I].Y);
                         ELSE
                           DrawBox(C.LGreenOnBlack,Parking[I].X,Parking[I].Y);
                           INC(L);
                         END;
                         INC(I);
                       END;
                       DrawPlayer(Player.X,Player.Y);
                       
                       IF I=L THEN (* NEW LEVEL *)
                         IF NumLevel<LEN(Levels)-1 THEN
                           INC(NumLevel); 
                         ELSE
                           NumLevel:=1;
                         END;
                         C.Fill(C.LWhiteOnGray); 
                         LoadLevels(NumLevel);
                         W.mciSendString("play MUSIC from 0", NIL, 0, 0);
                       END;
                       
                     END;
                      
      | W.MOUSE_EVENT: ;
      
    ELSE
    END; 
                                            
  UNTIL (CD.KeyCode=W.VK_ESCAPE) OR Exit;

  W.Shutdown();
END Program1.
